您的位置:首页 > 其它

hdu 4751 Divide Groups(判完美二分图)

2014-08-09 12:58 309 查看
题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4751

[align=left]Problem Description[/align]



  This year is the 60th anniversary of NJUST, and to make the celebration more colorful, Tom200 is going to invite distinguished alumnus back to visit and take photos.

  After carefully planning, Tom200 announced his activity plan, one that contains two characters:

  1. Whether the effect of the event are good or bad has nothing to do with the number of people join in.

  2. The more people joining in one activity know each other, the more interesting the activity will be. Therefore, the best state is that, everyone knows each other.

  The event appeals to a great number of alumnus, and Tom200 finds that they may not know each other or may just unilaterally recognize others. To improve the activities effects, Tom200 has to divide all those who signed up into groups to take part in the activity
at different time. As we know, one's energy is limited, and Tom200 can hold activity twice. Tom200 already knows the relationship of each two person, but he cannot divide them because the number is too large.

  Now Tom200 turns to you for help. Given the information, can you tell if it is possible to complete the dividing mission to make the two activity in best state.
 

[align=left]Input[/align]
  The input contains several test cases, terminated by EOF.

  Each case starts with a positive integer n (2<=n<=100), which means the number of people joining in the event.

  N lines follow. The i-th line contains some integers which are the id

of students that the i-th student knows, terminated by 0. And the id starts from 1.
 

[align=left]Output[/align]
  If divided successfully, please output "YES" in a line, else output "NO".

 

[align=left]Sample Input[/align]

3
3 0
1 0
1 2 0

 

[align=left]Sample Output[/align]

YES

题意就是判断是否是完美的二分图。。

BFS加邻接矩阵

代码:

#include<stdio.h>
#include<string.h>
#include<iostream>
#include<algorithm>
#include<string>
#include<math.h>
#include<stdlib.h>
#include<map>
#include<queue>
#define max(x,y)x>y?:xy
#define min(x,y)x<y?x:y
using namespace std;

const int maxn=110;
int n,ans;
int mp[maxn][maxn];
int vis[maxn];
queue<int>q;
int bfs(int u)
{
while(!q.empty())
q.pop();
q.push(u);
vis[u]=0;
while(!q.empty())
{
int tmp=q.front();
q.pop();
for(int i=1;i<=n;i++)
{
if(mp[tmp][i]&&mp[i][tmp]||i==tmp)
continue;
if(vis[i]==-1)
{
vis[i]=vis[tmp]^1;
q.push(i);
}
else if(vis[i]==vis[tmp])
return 0;
}
}
return 1;
}
int main()
{
//freopen("in.txt","r",stdin);
while(scanf("%d",&n)!=EOF)
{
memset(mp,0,sizeof(mp));
for(int i=1;i<=n;i++)
{
int num;
while(scanf("%d",&num),num)
mp[i][num]=1;
}
memset(vis,-1,sizeof(vis));
int ok=1;
for(int i=1;i<=n;i++)
if(vis[i]==-1)
{
if(!bfs(i))
{
ok=0;
break;
}
}
if(ok)
printf("YES\n");
else
printf("NO\n");
}
return  0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: